//+------------------------------------------------------------------+
//|                                                     michszyb.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property version   "1.00"
#property strict
//-------------------------------------------------------------------------------------------------
//Global Order SetUp
//-------------------------------------------------------------------------------------------------
extern string GlobalEAInputs="Inputs for all Trades";//Alert
extern double LotSize=0.01;//Lot size
extern int    EA_Slippage=3;//Slippage
extern int    EA_StopLoss=500;//StopLoss
extern int    EA_TakeProfit=0;//TakeProfit
extern string EA_Comment="Place Comment Here";//Comment
extern int    EA_MagicNumber=0001;//Magic Number
extern color  EA_ArrowColor=clrNONE;//Arrow Color
extern string EA_break="";//=======================================
//-------------------------------------------------------------------------------------------------
//Moving Average Indicator
//-------------------------------------------------------------------------------------------------
//Fast Moving Average
extern string Fast_MASettings="Fast Moving Average";//Alert
extern int    Fast_MAperiod=5;//Fast MA Period
extern int    Fast_MAindshift=0;//Fast MA Indicator Shift
extern string Choose_FastMA_CalcMethod="0=Simple,1=Exponential,2=Smoothed,3=Linear Weighted";//Choose the Calculation Method for the Fast MA
extern int    Fast_MAcalcMethod=3;//Calculation Method 
extern string Choose_FastMA_AppliedPrice="0=Close,1=Open,2=High,3=Low,4=Median Price,5=Typical Price,6=Weighted Close";
extern int    Fast_MAappliedprice=0;//Applied Price
extern int    Fast_MAbufferShift=1;//Fast Moving Average Buffer Shift
extern string Fast_break="";//=======================================
//-------------------------------------------------------------------------------------------------+++++
//Slow Moving Average
extern string Slow_MASettings_28="Slow Moving Average 28";//Alert
extern int    Slow_MAperiod_28=28;//Slow MA Period
extern int    Slow_MAindshift_28=0;//Slow MA Indicator Shift
extern string Choose_SlowMA_CalcMethod_28="0=Simple,1=Exponential,2=Smoothed,3=Linear Weighted";//Choose the Calculation Method for the Slow MA
extern int    Slow_MAcalcMethod_28=1;//Calculation Method 
extern string Choose_SlowMA_AppliedPrice_28="0=Close,1=Open,2=High,3=Low,4=Median Price,5=Typical Price,6=Weighted Close";
extern int    Slow_MAappliedprice_28=0;//Applied Price
extern int    Slow_MAbufferShift_28=1;//Slow Moving Average Buffer Shift
extern string Slow_break_28="";//=======================================
//-------------------------------------------------------------------------------------------------+++++
//Slow Moving Average
extern string Slow_MASettings_18="Slow Moving Average 18";//Alert
extern int    Slow_MAperiod_18=28;//Slow MA Period
extern int    Slow_MAindshift_18=0;//Slow MA Indicator Shift
extern string Choose_SlowMA_CalcMethod_18="0=Simple,1=Exponential,2=Smoothed,3=Linear Weighted";//Choose the Calculation Method for the Slow MA
extern int    Slow_MAcalcMethod_18=1;//Calculation Method 
extern string Choose_SlowMA_AppliedPrice_18="0=Close,1=Open,2=High,3=Low,4=Median Price,5=Typical Price,6=Weighted Close";
extern int    Slow_MAappliedprice_18=0;//Applied Price
extern int    Slow_MAbufferShift_18=1;//Slow Moving Average Buffer Shift
extern string Slow_break_18="";//=======================================
//-------------------------------------------------------------------------------------------------+++++
//Slow Moving Average
extern string Slow_MASettings_12="Slow Moving Average 28";//Alert
extern int    Slow_MAperiod_12=12;//Slow MA Period
extern int    Slow_MAindshift_12=0;//Slow MA Indicator Shift
extern string Choose_SlowMA_CalcMethod_12="0=Simple,1=Exponential,2=Smoothed,3=Linear Weighted";//Choose the Calculation Method for the Slow MA
extern int    Slow_MAcalcMethod_12=1;//Calculation Method 
extern string Choose_SlowMA_AppliedPrice_12="0=Close,1=Open,2=High,3=Low,4=Median Price,5=Typical Price,6=Weighted Close";
extern int    Slow_MAappliedprice_12=0;//Applied Price
extern int    Slow_MAbufferShift_12=1;//Slow Moving Average Buffer Shift
extern string Slow_break_12="";//=======================================
                               //Moving Average
double Fast_MA_5=iMA(NULL,0,Fast_MAperiod,Fast_MAindshift,Fast_MAcalcMethod,Fast_MAappliedprice,Fast_MAbufferShift);
double Slow_MA_28=iMA(NULL,0,Slow_MAperiod_28,Slow_MAindshift_28,Slow_MAcalcMethod_28,Slow_MAappliedprice_28,Slow_MAbufferShift_28);
double Slow_MA_18=iMA(NULL,0,Slow_MAperiod_18,Slow_MAindshift_18,Slow_MAcalcMethod_18,Slow_MAappliedprice_18,Slow_MAbufferShift_18);
double Slow_MA_12=iMA(NULL,0,Slow_MAperiod_12,Slow_MAindshift_12,Slow_MAcalcMethod_12,Slow_MAappliedprice_12,Slow_MAbufferShift_12);
//-------------------------------------------------------------------------------------------------+++++
double pips;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   double ticksize=MarketInfo(Symbol(),MODE_TICKSIZE);
   if(ticksize==0.00001 || ticksize==0.001)
      pips=ticksize*10;
   else pips=ticksize;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason){}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   if(NewBar()==true)
     {
      CheckTradeCondition();
      GetLastError();
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CheckTradeCondition()
  {
// Open Long Positions
   if(Fast_MA_5>Slow_MA_28)
     {
      OpenLongPos();Print("Long Open - 5 crosses 28 up");
      GetLastError();
     }
   if(Fast_MA_5<Slow_MA_12)
     {
      CloseLongPos();Print("Long Close - 5 crosses 12 down");
      GetLastError();
     }
// Open Short Positions
   if(Fast_MA_5<Slow_MA_18)
     {
      OpenShortPos();Print("Short Open - 5 crosses 18 down");
      GetLastError();
     }
   if(Fast_MA_5>Slow_MA_12)
     {
      CloseShortPos();Print("Short Close - 5 crosses 12 up");
      GetLastError();
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool NewBar()
  {
   static datetime LastTime=0;

   if(Time[0]!=LastTime)
     {
      LastTime=Time[0];
      return (true);
     }
   else
      return (false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OpenLongPos()
  {
   if(OrdersTotal()==0)
     {
      //-------------------------------------------------------------------------------------------------+++++
      int NewLongTicket=0;//Long ticket declaration
      double Static_SL_Long=NormalizeDouble(Ask-(EA_StopLoss*pips),Digits);
      double Static_TP_Long=NormalizeDouble(Ask+(EA_TakeProfit*pips),Digits);
      //-------------------------------------------------------------------------------------------------+++++
      //New Long Order 
      NewLongTicket=OrderSend(Symbol(),OP_BUY,LotSize,Ask,EA_Slippage,Static_SL_Long,Static_TP_Long,EA_Comment,EA_MagicNumber,EA_ArrowColor);
      //Error Check
      if(NewLongTicket<0)
        {
         Print("New Long Order Error Occured : ",GetLastError());
        }
      if(NewLongTicket>0)
         if(GetLastError()>2)
           {
            Print("New Long Order Succesfull");
           }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OpenShortPos()
  {
   if(OrdersTotal()==0)
     {
      //-------------------------------------------------------------------------------------------------+++++
      int NewShortTicket=0;//Short ticket declaration
      double Static_SL_Short=NormalizeDouble(Bid+(EA_StopLoss*pips),Digits);
      double Static_TP_Short=NormalizeDouble(Bid-(EA_TakeProfit*pips),Digits);
      //-------------------------------------------------------------------------------------------------+++++
      //New Short Order
      NewShortTicket=OrderSend(Symbol(),OP_SELL,LotSize,Bid,EA_Slippage,Static_SL_Short,Static_TP_Short,EA_Comment,EA_MagicNumber,EA_ArrowColor);
      //Error Check
      if(NewShortTicket<0)
        {
         Print("New Short Order Error Occured : ",GetLastError());
        }
      if(NewShortTicket>0)
         if(GetLastError()>2)
           {
            Print("New Short Order Succesfull");
           }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CloseLongPos()
  {
//-------------------------------------------------------------------------------------------------+++++
   int CloseLongTicket=0;
//-------------------------------------------------------------------------------------------------+++++ 
//Close Long Position
   for(int cnt=OrdersTotal()-1; cnt>=0; cnt--)
     {
      if(OrderSelect(cnt,SELECT_BY_POS))
         if(OrderSymbol()==Symbol())
            if(OrderComment()==EA_Comment)
               if(OrderMagicNumber()==EA_MagicNumber)
                 {
                  CloseLongTicket=OrderClose(OrderTicket(),OrderLots(),Bid,EA_Slippage,EA_ArrowColor);
                  //Error Check
                  if(CloseLongTicket<0)
                    {
                     Print("Close Long Order Error Occured : ",GetLastError());
                    }
                  if(CloseLongTicket>0)
                     if(GetLastError()>2)
                       {
                        Print("Close Long Order Succesfull");
                       }
                 }
     }

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CloseShortPos()
  {
//-------------------------------------------------------------------------------------------------+++++
   int CloseShortTicket=0;
//-------------------------------------------------------------------------------------------------+++++ 
//Close Short Position
   for(int cnt=OrdersTotal()-1; cnt>=0; cnt--)
     {
      if(OrderSelect(cnt,SELECT_BY_POS))
         if(OrderSymbol()==Symbol())
            if(OrderComment()==EA_Comment)
               if(OrderMagicNumber()==EA_MagicNumber)
                 {
                  CloseShortTicket=OrderClose(OrderTicket(),OrderLots(),Bid,EA_Slippage,EA_ArrowColor);
                  //Error Check
                  if(CloseShortTicket<0)
                    {
                     Print("Close Short Order Error Occured : ",GetLastError());
                    }
                  if(CloseShortTicket>0)
                     if(GetLastError()>2)
                       {
                        Print("Close Short Order Succesfull");
                       }
                 }
     }
  }
//+------------------------------------------------------------------+ 
